{%- import "src/_rda_template.j2" as rda_dmp_cs with context -%}
{%- import "src/_utils.j2" as utils with context -%}
{%- import "src/_tree_utils.j2" as tree with context -%}

{#- ------------------------------------------------------------  -#}
{#- globals to THIS file, which we call locals... -#}
{#- ------------------------------------------------------------  -#}
{#- variables global to this file, not meant to be used by the caller  -#}

{%- set local_ns = namespace(description="contributor_contact") -%}

{#- why are the following vars not defined in globals? -#}
{#- because they are local to this file only -#}
{#- and this file is only called from _create_object.j2 -#}
{#- not sure this is very robust: it looks like it is best to have all -#}
{#- in globals. This is safe as globals are only ever passed as parameters -#}
{#- while the local vars are known via import with context.... -#}
{%- set local_ns.contributor_root = none -%}
{%- set local_ns.contributor_id_root = none -%}
{%- set local_ns.contributor_id_types = ["orcid", "isni", "openid", "other"] -%}

{#- ----------------------------------------------------------------------- -#}
{#-  creation macros                                       -#}
{#- ----------------------------------------------------------------------- -#}

{%- macro createContributor(globals, dmp_being_built, uuid) -%}
  {#-  recall that we must do a deep copy of rda_dmp_cs.contributor -#}
  {#-  as in jinja2 all vars are accessed by reference... -#}

  {{ utils.deepCopy(rda_dmp_cs.contributor) }}
  {#- we retrieve the copy of rda_dmp_cs.contributor -#}
  {%- set obj = utils.global_ns.var_stack.pop() -%} 
  {%- set contributors = dmp_being_built.contributor -%}
  {%- do contributors.append(obj) -%}
  {%- do dmp_being_built.update({ "contributor" : contributors }) -%}

  {#- we need to record the uuid for this contributor -#}
  {#- for further comparison -#}
  {%- set local_ns.contributor_root = uuid -%}
  {%- set local_ns.contributor_id_root = none -%}
{%- endmacro -%}


{%- macro createContributorId(globals, dmp_being_built, uuid) -%}
  {#- in DSW we allow for more than one contributor_id block -#}
  {#- but RDA RDA_DMP_CS CS does not, so we pick the first encountered -#}
  {#- -#}
  {#- we test this by checking the length of -#}
  {#- dmp_being_built.contributor[dmp_being_built.contributor|length - 1].contributor_id  -#}
  {#- if zero, it means dans the dict contributor_id = {}, ie, no keys -#}
  {#- -#}
  {#- note that if contributor_id already exists, we do nothing -#}

  {%- if dmp_being_built.contributor[dmp_being_built.contributor|length - 1].contributor_id|length == 0 -%}
    {{ utils.deepCopy(rda_dmp_cs.contributor_id) }}
    {%- set obj = utils.global_ns.var_stack.pop() -%}
    {%- do dmp_being_built.contributor[dmp_being_built.contributor|length - 1].update({ "contributor_id" : obj }) -%}

    {#- we need to control the update  of contributor.contributor_id -#}
    {#- we keep track of its uuid  -#}
    {%- set local_ns.contributor_id_root = uuid -%}
  {%- else -%}
    {%- set local_ns.contributor_id_root = none -%}
  {%- endif -%}
{%- endmacro -%}


{%- macro createAndFillContact(dmp_being_built, uuid) -%}
  {#- if a contact person already exists, we do nothing:   -#}
  {#- in DSW we allow for more than one contact person -#}
  {#- but RDA RDA_DMP_CS CS does not, so we pick the first encountered -#}
  {#- -#}
  {#- we test this by checking if dmp_being_built.contact: {} is empty or not -#}
  {%- if dmp_being_built.contact|length == 0 -%}

    {%- set contributor = dmp_being_built.contributor[dmp_being_built.contributor|length - 1] -%}

    {#- we'll populate contact with the last contributor entered   -#}
    {#- in dmp_being_built.contributor[dmp_being_built.contributor|length-1]
    {#- this is correct because of the chronological   -#}
    {#- sequencing of the annotations' occurrences -#}
    {#- -#}
    {#- the roles multi-choice question,
    {#- whose choice 'contact person' is annotated as 'rdaContact' -#}
    {#- comes as the last question in the contributor block -#}
    {#- which means that the contributor object is already -#}
    {#- created, and filled in -#}
    {#- -#}

    {{ utils.deepCopy(rda_dmp_cs.contact) }}
    {%- set obj =  utils.global_ns.var_stack.pop() -%}
    {%- do dmp_being_built.update( { "contact" : obj }) -%} 

    {{ fillContact(dmp_being_built, contributor) }}

  {%- endif -%}
{%- endmacro -%} 

{%- macro fillContact(dmp_being_built, contributor) -%}

  {%- do dmp_being_built.contact.update( { "name" : contributor.name }) -%}
  {%- do dmp_being_built.contact.update( { "mbox" : contributor.mbox }) -%}

  {#- by this below, we actually do a copy of contributor.contributor_id -#}
  {#- we MUST do this, as in jinja2 all vars are accessed by reference... -#}

  {{ utils.deepCopy(contributor.contributor_id) }}
  {%- set obj = utils.global_ns.var_stack.pop() -%}
  {%- do dmp_being_built.contact.update( { "contact_id" : obj }) -%}
{%- endmacro -%}

{#- ----------------------------------------------------------------------- -#}
{#-  updating macros ()                                       -#}
{#- ----------------------------------------------------------------------- -#}

{#- ----------------------------------------------------------------------- -#}
{#-  contributor name                                       -#}
{#- ----------------------------------------------------------------------- -#}

{%- macro processContributorName(globals, dmp_being_built, reply, uuid) -%}
  {#- actually, here and below, there is no need to check for anything: -#}
  {#- it is not possible to mix up a contributor object and its attribute -#}
  {#- as, each time an attribute is answered, the contributour object has necessarily -#}
  {#- been created before hand -#}
  {#- this is the case there is no limit to the number of contributor that -#}
  {#- can be created -#}
  
  {%- do dmp_being_built.contributor[dmp_being_built.contributor|length - 1].update({ "name" : reply }) -%}
{%- endmacro -%}
  

{#- ----------------------------------------------------------------------- -#}
{#-  contributor_id ROR                                    -#}
{#- ----------------------------------------------------------------------- -#}

{#- if there exists a ROR id (for organisation): this annotation comes first -#}


{%- macro createAndFillContributorIdROR(globals, dmp_being_built, reply, uuid) -%}

  {%- if dmp_being_built.contributor[dmp_being_built.contributor|length - 1].contributor_id|length == 0 -%}
    {{ createContributorId(globals, dmp_being_built, uuid) }}
    {{ updateContributorIdType(dmp_being_built, "ror") }}
    {{ updateContributorIdIdentifier(dmp_being_built, reply) }}

    {#- note that ContributorIdROR" is not a child of ContributorId -#}
    {#- but of Contributor (in the annotation tree) -#}

    {%- set local_ns.contributor_id_root = none -%}
  {%- endif -%}
{%- endmacro -%}



{#- ----------------------------------------------------------------------- -#}
{#-  contributor_id type                                       -#}
{#- ----------------------------------------------------------------------- -#}

{%- macro updateContributorIdType(dmp_being_built, reply) -%}
 {%- if reply|lower in local_ns.contributor_id_types -%}
    {%- do dmp_being_built.contributor[dmp_being_built.contributor|length - 1].contributor_id.update({ "type" : reply|lower }) -%}
  {%- else  -%}
    {%- do dmp_being_built.contributor[dmp_being_built.contributor|length - 1].contributor_id.update({ "type" : "other" }) -%}
  {%- endif -%}
{%- endmacro -%}


{%- macro updateContributorIdIdentifier(dmp_being_built, reply) -%}
  {%- do dmp_being_built.contributor[dmp_being_built.contributor|length - 1].contributor_id.update({ "identifier" : reply}) -%}
{%- endmacro -%}


{%- macro processContributorIdType(globals, dmp_being_built, reply, uuid) -%}
  {#- as opposed to ContributorIdROR, ContributorIdType  -#}
  {#- is a child of ContributorId (in the annotation tree) -#}

  {{ tree.isChildOf(globals, uuid, local_ns.contributor_id_root) }}
  {%- set answer = tree.global_ns.var_stack.pop() -%}
  {%- if answer -%}
      {{ updateContributorIdType(dmp_being_built, reply) }}
  {%- endif -%}
{%- endmacro -%}

{#- ----------------------------------------------------------------------- -#}
{#-  contributor_id identifier                                       -#}
{#- ----------------------------------------------------------------------- -#}


{%- macro processContributorIdIdentifier(globals, dmp_being_built, reply, uuid) -%}
  {#- as opposed to ContributorIdROR, ContributorIdIdentifier  -#}
  {#- is a child of ContributorId (in the annotation tree) -#}

  {{ tree.isChildOf(globals, uuid, local_ns.contributor_id_root) }}
  {%- set answer = tree.global_ns.var_stack.pop() -%}

{#-  {{ " identifier " ~ reply ~ " local_ns.contributor_id_root " ~ local_ns.contributor_id_root ~ " uuid " ~ uuid ~ " answer " ~ answer ~ " " }} -#}

  {%- if answer -%}
      {{ updateContributorIdIdentifier(dmp_being_built, reply) }}
  {%- endif -%}
{%- endmacro -%}

{#- ----------------------------------------------------------------------- -#}
{#-  contributor_id role                                -#}
{#- ----------------------------------------------------------------------- -#}

{%- macro processContributorRole(globals, dmp_being_built, reply, uuid) -%}
  {%- set role_list = dmp_being_built.contributor[dmp_being_built.contributor|length - 1].role -%}
  {%- do role_list.append(reply) -%}
  {%- do dmp_being_built.contributor[dmp_being_built.contributor|length - 1].update({ "role" : role_list }) -%}
{%- endmacro -%}
  
{%- macro processContributorMbox(globals, dmp_being_built,  reply, uuid) -%}
  {%- do dmp_being_built.contributor[dmp_being_built.contributor|length - 1].update({ "mbox" : reply }) -%}
{%- endmacro -%}
  


{#- ----------------------------------------------------------------------- -#}
{#-  macros that test for cardinalities                                     -#}
{#- ----------------------------------------------------------------------- -#}

{% macro checkContact(dmp_being_built) %}
  {% set contact = dmp_being_built.contact %}
    {%- if not contact -%}
      {{ utils.warningMessage(false, "dmp.contact does not exist ") }}
    {%- else -%}
      {%- if contact is not mapping-%}
        {{ utils.warningMessage(false, "dmp.contact is not mapping ") }}
      {%- else -%}
        {%- if not contact.name or not contact.mbox or not contact.contact_id or not contact.contact_id.identifier or not contact.contact_id.type -%}
          {{ utils.warningMessage(false, "Unsatisfied constraint(s) for dmp.contact : ") }}
          {%- if not contact.name -%}
            {{ utils.warningMessage(false, "- dmp.contributor.contact.name must exist ") }}
          {%- endif -%}
          {%- if not contact.mbox -%}
            {{ utils.warningMessage(false, "- dmp.contributor.contact.mbox must exist ") }}
          {%- endif -%}
          {%- if not contact.contact_id -%}
            {{ utils.warningMessage(false, "- dmp.contributor.contact.contact_id must exist ") }}
          {%- endif -%}
          {%- if not contact.contact_id.identifier -%}
            {{ utils.warningMessage(false, "- dmp.contributor.contact.contact_id.identifier must exist ") }}
          {%- endif -%}
          {%- if not contact.contact_id.type -%}
            {{ utils.warningMessage(false, "- dmp.contributor.contact.contact_id.type must exist ") }}
          {%- endif -%}
        {%- else -%}
          {# {{ utils.warningMessage(true, "All keys and values are present ") }} #}
        {%- endif -%}
    {%- endif -%}
  {%- endif -%}
{%- endmacro -%}

{% macro checkContributor(dmp_being_built) %}
     {%- if not dmp_being_built.contributor -%}
      {# {{ utils.warningMessage(false, "dmp.contributor does not exist ") }} #}
    {%- else -%}
      {%- if dmp_being_built.contributor is not sequence-%}
          {{ utils.warningMessage(false, "dmp.contributor is not sequence ") }}
      {%- else -%}
        {% if dmp_being_built.contributor %}
          {% for contributor in dmp_being_built.contributor %}
            {%- if not contributor.name or not contributor.contributor_id or not contributor.contributor_id.identifier or not contributor.contributor_id.type or not contributor.role-%}
             {{ utils.warningMessage(false, "Unsatisfied constraint(s) for dmp.contributor : ") }}
            {%- if not contributor.name -%}
              {{ utils.warningMessage(false, "- dmp.contributor.name must exist ") }}
            {%- endif -%}
            {%- if not contributor.contributor_id -%}
              {{ utils.warningMessage(false, "- dmp.contributor.contributor_id must exist ") }}
            {%- endif -%}
            {%- if not contributor.contributor_id.identifier -%}
              {{ utils.warningMessage(false, "- dmp.contributor.contributor_id.identifier must exist ") }}
            {%- endif -%}
            {%- if not contributor.contributor_id.type -%}
              {{ utils.warningMessage(false, "- dmp.contributor.contributor_id.type must exist ") }}
            {%- endif -%}
            {%- if not contributor.role -%}
              {{ utils.warningMessage(false, "- dmp.contributor.role must exist") }}
            {%- endif -%}
          {%- else -%}
            {# {{ utils.warningMessage(true, "All keys and values are present ") }} #}
          {%- endif -%}
          {% endfor %}
        {% endif %}
      {% endif %}
    {% endif %}
{%- endmacro -%}


{%- macro checkConstraints(dmp_being_built) -%}

{{ checkContact(dmp_being_built) }}
{{ checkContributor(dmp_being_built) }}
    
{%- endmacro -%}


